<app-loading *ngIf="isLoading"></app-loading>
<form nz-form [formGroup]="form">
  <div nz-row [nzGutter]="[30, 10]">
    <div nz-col nzXs="24" nzLg="12">
      <mb-select
        (ngModelChange)="onSubjectChange($event)"
        [mbDataSelects]="subjectOptions"
        [mbType]="
          isSubmitted && form.controls['subject'].errors ? 'error' : 'default'
        "
        [mbShowError]="isSubmitted && form.controls['subject'].errors !== null"
        [mbErrors]="form.controls['subject'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.insuranceRate.label.subject'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.insuranceRate.label.subject'
        }}"
        mbLabelText="{{
          'insurance.insuranceRate.label.subject' | translate
        }} <span class='label__required'>*</span>"
        formControlName="subject"
      ></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-select
        [mbDataSelects]="subjectEmployeeOptions"
        [mbType]="
          isSubmitted && form.controls['subjectEmployee'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['subjectEmployee'].errors !== null
        "
        [mbErrors]="form.controls['subjectEmployee'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.insuranceRate.label.subjectEmployee'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.insuranceRate.label.subjectEmployee'
        }}"
        mbLabelText="{{
          'insurance.insuranceRate.label.subjectEmployee' | translate
        }} <span class='label__required'>*</span>"
        formControlName="subjectEmployee"
      ></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-select
        [mbDataSelects]="insuranceOptions"
        [mbType]="
          isSubmitted && form.controls['insuranceId'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['insuranceId'].errors !== null
        "
        [mbErrors]="form.controls['insuranceId'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.insuranceRate.label.insurance'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.insuranceRate.label.insurance'
        }}"
        mbLabelText="{{
          'insurance.insuranceRate.label.insurance' | translate
        }} <span class='label__required'>*</span>"
        formControlName="insuranceId"
      ></mb-select>
    </div>
    <div nz-col nzXs="24" nzLg="12">
      <mb-input-text
        [mbType]="
          isSubmitted && form.controls['insuranceName'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['insuranceName'].errors !== null
        "
        [mbErrors]="form.controls['insuranceName'].errors"
        [mbMaxLength]="100"
        [mbErrorDefs]="[
          {
            errorName: 'maxlength',
            errorDescription:
              'insurance.validate.maxLength'
              | translate: { numberLength: '100' }
          },
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.insuranceRate.label.insuranceName'
          }
        ]"
        mbPlaceholderText="{{
          'insurance.placeholder.input'
            | translateLabel: 'insurance.insuranceRate.label.insuranceName'
        }}"
        mbLabelText="{{
          'insurance.insuranceRate.label.insuranceName' | translate
        }} <span class='label__required'>*</span>"
        formControlName="insuranceName"
      ></mb-input-text>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-input-text
        appNumberic
        [num]="3"
        [mbType]="
          isSubmitted && form.controls['contributionPpm'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['contributionPpm'].errors !== null
        "
        [mbErrors]="form.controls['contributionPpm'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.insuranceRate.label.contributionPpm'
          },
          {
            errorName: 'min',
            errorDescription: 'insurance.validate.min' | translate: { min: 0 }
          },
          {
            errorName: 'max',
            errorDescription: 'insurance.validate.max' | translate: { max: 100 }
          }
        ]"
        mbPlaceholderText="{{
          'insurance.placeholder.input'
            | translateLabel: 'insurance.insuranceRate.label.contributionPpm'
        }}"
        mbLabelText="{{
          'insurance.insuranceRate.label.contributionPpm' | translate
        }} <span class='label__required'>*</span>"
        formControlName="contributionPpm"
      ></mb-input-text>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-select
        [mbDataSelects]="statusOptions"
        [mbType]="
          isSubmitted && form.controls['flagStatus'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['flagStatus'].errors !== null
        "
        [mbErrors]="form.controls['flagStatus'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.common.label.flagStatus'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.common.label.flagStatus'
        }}"
        mbLabelText="{{
          'insurance.common.label.flagStatus' | translate
        }} <span class='label__required'>*</span>"
        formControlName="flagStatus"
      ></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-date-picker
        [mbType]="
          isSubmitted && form.controls['fromDate'].errors ? 'error' : 'default'
        "
        [mbShowError]="isSubmitted && form.controls['fromDate'].errors !== null"
        [mbErrors]="form.controls['fromDate'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.common.label.fromDate'
          }
        ]"
        formControlName="fromDate"
        mbLabelText="{{
          'insurance.common.label.fromDate' | translate
        }} <span class='label__required'>*</span>"
      ></mb-date-picker>
    </div>

    <div nz-col nzXs="24" nzLg="12">
      <mb-date-picker
        formControlName="toDate"
        mbLabelText="{{ 'insurance.common.label.toDate' | translate }}"
      ></mb-date-picker>
    </div>

    <div nz-col nzXs="24" nzLg="24">
      <mb-input-text
        [mbType]="
          isSubmitted && form.controls['description'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['description'].errors !== null
        "
        [mbErrors]="form.controls['description'].errors"
        [mbMaxLength]="250"
        [mbErrorDefs]="[
          {
            errorName: 'maxlength',
            errorDescription:
              'insurance.validate.maxLength'
              | translate: { numberLength: '250' }
          }
        ]"
        formControlName="description"
        mbPlaceholderText="{{
          'insurance.placeholder.input'
            | translateLabel: 'insurance.common.label.description'
        }}"
        mbLabelText="{{ 'insurance.common.label.description' | translate }}"
      >
      </mb-input-text>
    </div>
  </div>
</form>
